<template>
  <div>
    <d-col class="form-group" >
      <label :for="inputId">{{data.label}}<span v-if="data.required" style="color: red">*</span>:</label>
      <div class="d-flex m-1" v-for="(value, item) in newValue" :key="value.id">
        <d-input
        :id="inputId"
        :type="typeOfInput"
        :placeholder="data.label"
        v-model="newValue[item]"
        :disabled="disabled"
        />
        <b-button variant="success" @click="addProductId" class="ml-1 mr-1">+</b-button>
        <b-button variant="danger" @click="removeProductId(item)" v-if="item !== 0">-</b-button>
      </div>
      <p v-for="error in errors" :key="error.id" class="error-message">{{error}}</p>
      <b-form-checkbox
        class="ml-2"
        id="checkbox-1"
        v-model="status"
      >
      I want to use all products from this platform
    </b-form-checkbox>
    </d-col>
  </div>
</template>

<script>
export default {
  data() {
    return {
      newValue: [],
      status: false,
      disabled: false,
    };
  },
  props: ['data', 'errors', 'typeOfInput', 'inputId', 'value', 'input'],
  watch: {
    newValue() {
      this.createArrayToSend();
    },
    status() {
      const { status } = this;
      if (status) {
        this.$emit('input').input([], this.inputId);
        this.disabled = true;
        return;
      }
      this.createArrayToSend();
      this.disabled = false;
    },
  },
  methods: {
    addProductId() {
      this.newValue.push('');
    },
    removeProductId(item) {
      this.newValue.splice(item, 1);
    },
    createArrayToSend() {
      const { newValue } = this;
      const arrayToSend = [];
      newValue.forEach((element) => {
        if (element === '' || element === ' ') {
          return;
        }
        arrayToSend.push(element);
      });
      return this.$emit('input').input(arrayToSend, this.inputId);
    },
  },
  mounted() {
    if (this.value === undefined) {
      this.newValue = [];
      this.newValue[0] = '';
      return;
    }
    this.newValue = this.value;
  },
};

</script>
